package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.data.entity.CompassBindAdvertisers;
import cn.com.ctop.job.kuaishou.data.service.CompassBindAdvertisersService;
import cn.com.ctop.job.kuaishou.data.service.IKuaishouVideoListService;
import cn.com.ctop.job.kuaishou.data.service.IOauthTokenService;
import cn.com.ctop.job.kuaishou.data.utils.Check;
import cn.com.ctop.job.kuaishou.data.utils.DateUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Slf4j
@Component
public class CompassBindAdvertisersJob {
    @Autowired
    private IOauthTokenService tokenService;
    @Autowired
    private CompassBindAdvertisersService compassBindAdvertisersService;

    private static ExecutorService campaignExecutorService = Executors.newFixedThreadPool(3);
    private static ExecutorService unitExecutorService = Executors.newFixedThreadPool(3);

    /**
     * 获取罗盘绑定广告主列
     * 当前快手ID,账户ID 固定写死
     */

    @XxlJob("compassAdvertisers")
    public void compassAdvertisers() throws Exception {
        //罗盘账户的「快手 id」，只能传递授权时使用的快手 id
/*        Long advertiserId = 4361966075L;
        String token = tokenService.getOuthTokenAccountId(39526067L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId, token);*/


        Long advertiserId2 = 4541748730L;
        String token2 = tokenService.getOuthTokenAccountId(52899077L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId2, token2);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId3 = 4541570865L;
        String token3 = tokenService.getOuthTokenAccountId(53452511L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId3, token3);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId4 = 4553133112L;
        String token4 = tokenService.getOuthTokenAccountId(53536379L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId4, token4);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId5 = 4553312997L;
        String token5 = tokenService.getOuthTokenAccountId(53561184L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId5, token5);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId6 = 4559392749L;
        String token6 = tokenService.getOuthTokenAccountId(53949803L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId6, token6);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId7 = 4559411840L;
        String token7 = tokenService.getOuthTokenAccountId(53955740L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId7, token7);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId8 = 4560670561L;
        String token8 = tokenService.getOuthTokenAccountId(54236994L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId8, token8);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId9 = 4569961384L;
        String token9 = tokenService.getOuthTokenAccountId(54938539L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId9, token9);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId10 = 4570173469L;
        String token10 = tokenService.getOuthTokenAccountId(54962281L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId10, token10);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId11 = 4571163963L;
        String token11 = tokenService.getOuthTokenAccountId(55007805L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId11, token11);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId12 = 4571182017L;
        String token12 = tokenService.getOuthTokenAccountId(55013575L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId12, token12);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId13 = 4561842445L;
        String token13 = tokenService.getOuthTokenAccountId(54238703L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId13, token13);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId14 = 4571213505L;
        String token14 = tokenService.getOuthTokenAccountId(55017193L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId14, token14);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId15 = 4571228536L;
        String token15 = tokenService.getOuthTokenAccountId(55025257L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId15, token15);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId16 = 4583857834L;
        String token16 = tokenService.getOuthTokenAccountId(55884757L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId16, token16);
        log.info("------【获取罗盘绑定广告主列】执行完成");



        Long advertiserId18 = 4583911135L;
        String token18 = tokenService.getOuthTokenAccountId(55909821L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId18, token18);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId19 = 4583930765L;
        String token19 = tokenService.getOuthTokenAccountId(55915385L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId19, token19);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId20 = 4583948298L;
        String token20 = tokenService.getOuthTokenAccountId(55920227L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId20, token20);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId21 = 4584290787L;
        String token21 = tokenService.getOuthTokenAccountId(56007657L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId21, token21);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId22 = 4584321933L;
        String token22 = tokenService.getOuthTokenAccountId(56023739L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId22, token22);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId23 = 4584356474L;
        String token23 = tokenService.getOuthTokenAccountId(56032555L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId23, token23);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId24 = 4584568971L;
        String token24 = tokenService.getOuthTokenAccountId(56123878L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId24, token24);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId25 = 4575459186L;
        String token25 = tokenService.getOuthTokenAccountId(55471475L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId25, token25);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId26 = 4575481308L;
        String token26 = tokenService.getOuthTokenAccountId(55474278L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId26, token26);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId27 = 4581144143L;
        String token27 = tokenService.getOuthTokenAccountId(55781258L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId27, token27);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId28 = 4588161116L;
        String token28 = tokenService.getOuthTokenAccountId(56543394L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId28, token28);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId29 = 4588168108L;
        String token29 = tokenService.getOuthTokenAccountId(56544763L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId29, token29);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId30 = 4588169157L;
        String token30 = tokenService.getOuthTokenAccountId(56547223L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId30, token30);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId31 = 4588172873L;
        String token31 = tokenService.getOuthTokenAccountId(56547921L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId31, token31);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId32 = 4588175126L;
        String token32 = tokenService.getOuthTokenAccountId(56545714L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId32, token32);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId33 = 4616881256L;
        String token33 = tokenService.getOuthTokenAccountId(57333858L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId33, token33);
        log.info("------【获取罗盘绑定广告主列】执行完成");


        Long advertiserId34 = 4620909365L;
        String token34 = tokenService.getOuthTokenAccountId(57445847L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId34, token34);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId35 = 4620938604L;
        String token35 = tokenService.getOuthTokenAccountId(57449840L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId35, token35);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId36 = 4620938604L;
        String token36 = tokenService.getOuthTokenAccountId(57449840L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId36, token36);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId37 = 4469799953L;
        String token37 = tokenService.getOuthTokenAccountId(48812224L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId37, token37);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId38 = 4636624659L;
        String token38 = tokenService.getOuthTokenAccountId(58238502L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId38, token38);
        log.info("------【获取罗盘绑定广告主列】执行完成");

        Long advertiserId39 = 4458996114L;
        String token39 = tokenService.getOuthTokenAccountId(58238502L);
        compassBindAdvertisersService.openapiGwUcV1Advertisers(advertiserId38, token38);
        log.info("------【获取罗盘绑定广告主列】执行完成");










    }

    private String getToken(String accountId) {
        CompassBindAdvertisers advertiser = compassBindAdvertisersService.getByAccountId(accountId);
        if (Check.isNull(advertiser)) {
            return null;
        }
        String token = null;
        String corporationName = advertiser.getCorporationName();
        if (!Check.isNull(corporationName) && corporationName.contains("骄阳")) {
            //723 骄阳token
            token = tokenService.getAgentTokenByAgentId(723L);
        } else {
            //汇创
            token = tokenService.getAgentTokenByAgentId(14L);
        }
        return token;
    }

    /**
     * 获取罗盘绑定广告主今日计划日报表
     */
    @XxlJob("compassAdNowDayCampaignDailyReport")
    public void compassAdNowDayCampaignDailyReport() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }
        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        campaignExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getCompassAdvertisersCampaignReportDaily(
                                Long.valueOf(accountId), token, nowDate, nowDate, 1);
                    }
                });
    }

    /**
     * 获取罗盘绑定广告主昨日日计划日报表
     */
    @XxlJob("compassAdYesterdayCampaignDailyReport")
    public void compassAdYesterdayCampaignDailyReport() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }
        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        String yesterday = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -1);
        campaignExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getCompassAdvertisersCampaignReportDaily(
                                Long.valueOf(accountId), token, yesterday, yesterday, 1);
                    }
                });
    }

    /**
     * 获取罗盘绑定广告主今日广告组日报表
     */
    @XxlJob("compassAdNowDayUnitDailyReport")
    public void compassAdNowDayUnitDailyReport() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }

        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        campaignExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getCompassAdvertisersUnitReportDaily(
                                Long.valueOf(accountId), token, nowDate, nowDate, 1);
                    }
                });
    }

    /**
     * 获取罗盘绑定广告主昨日广告组日报表
     */
    @XxlJob("compassAdYesterdayUnitDailyReport")
    public void compassAdYesterdayUnitDailyReport() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }
        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        String yesterday = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -1);
        campaignExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getCompassAdvertisersUnitReportDaily(
                                Long.valueOf(accountId), token, yesterday, yesterday, 1);
                    }
                });
    }

    /**
     * 获取罗盘绑定广告主今日素材日报表
     */
    @XxlJob("compassAdNowDayVideosDailyReport")
    public void compassAdNowDayVideosDailyReport() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }

        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        campaignExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getCompassAdvertisersVideosReportDaily(
                                Long.valueOf(accountId), token, nowDate, nowDate, 1);
                    }
                });
    }

    /**
     * 获取罗盘绑定广告主昨日素材日报表
     */
    @XxlJob("compassAdYesterdayVideosDailyReport")
    public void compassAdYesterdayVideosDailyReport() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }
        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        String yesterday = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -1);
        campaignExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getCompassAdvertisersVideosReportDaily(
                                Long.valueOf(accountId), token, yesterday, yesterday, 1);
                    }
                });
    }


    private static ExecutorService nowExecutorService = Executors.newFixedThreadPool(5);

    @Autowired
    private IKuaishouVideoListService videoListService;

    /**
     * 当日视频物料
     *
     * @throws Exception
     */
    @XxlJob("compassNowDayVideoList")
    public void compassNowDayVideoList() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }
        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        nowExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getVideoList(Long.valueOf(accountId), token, nowDate, nowDate, 1);
                    }
                });
    }

    /**
     * 昨天日视频物料
     *
     * @throws Exception
     */
    @XxlJob("compassYesterdayVideoList")
    public void compassYesterdayVideoList() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }
        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        String yesterday = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -1);
        nowExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getVideoList(Long.valueOf(accountId), token, yesterday, yesterday, 1);
                    }
                });
    }

    /**
     * 无时间，取全部
     *
     * @throws Exception
     */
    @XxlJob("compassAllVideoList")
    public void compassAllVideoList() throws Exception {
        String accountId = XxlJobHelper.getJobParam(); // 执行参数
        if (Check.isNull(accountId)) {
            log.error("入参为空");
            return;
        }
        String token = getToken(accountId);
        if (Check.isNull(token)) {
            log.error("token 为空 ！！！");
            return;
        }
        nowExecutorService.submit(
                new Runnable() {
                    @Override
                    public void run() {
                        compassBindAdvertisersService.getVideoList(Long.valueOf(accountId), token, null, null, 1);
                    }
                });
    }
}
